# Action cable

### What is action cable?

Action Cable seamlessly integrates WebSockets with the rest of your Rails application. It allows for real-time features to be written in Ruby in the same style and form as the rest of your Rails application, while still being performant and scalable. It's a full-stack offering that provides both a client-side JavaScript framework and a server-side Ruby framework. You have access to your full domain model written with Active Record or your ORM of choice.

### How it works?

Action Cable uses WebSockets instead of the HTTP request-response protocol. Both Action Cable and WebSockets introduce some less familiar terminology:

![Action cable img](https://geekhmer.github.io/images/rails_5_actioncable_concepts.png)

#### Consumers

The client of a WebSocket connection is called the consumer. In Action Cable the consumer is created by the client-side JavaScript framework.

#### Channels

Each consumer can in turn subscribe to multiple channels. Each channel encapsulates a logical unit of work, similar to what a controller does in a regular MVC setup. For example, you could have a ChatChannel and an AppearancesChannel, and a consumer could be subscribed to either or to both of these channels. At the very least, a consumer should be subscribed to one channel.

#### Subscribers

When the consumer is subscribed to a channel, they act as a subscriber. The connection between the subscriber and the channel is called a subscription. A consumer can act as a subscriber to a given channel any number of times. For example, a consumer could subscribe to multiple channels at the same time.

#### Pub/Sub

Pub/Sub, or Publish-Subscribe, refers to a message queue paradigm whereby senders of information (publishers), send data to an abstract class of recipients (subscribers), without specifying individual recipients. Action Cable uses this approach to communicate between the server and many clients.

### Server-Side Components

#### Connections

For every WebSocket accepted by the server, a connection object is instantiated. This object becomes the parent of all the channel subscriptions that are created from there on. The connection itself does not deal with any specific application logic beyond authentication and authorization. The client of a WebSocket connection is called the connection consumer. An individual user will create one consumer-connection pair per browser tab, window, or device they have open.

    module ApplicationCable

class Connection < ActionCable::Connection::Base
identified_by :current_user

    '''
    verified_user = User.find_by(id: cookies.encrypted['_session']['user_id'])
    '''

This example relies on the fact that you will already have handled authentication using session, you use cookie store for the session, your session cookie is named \_session and the user ID key is user_id you can use this approach

#### Channels

A channel encapsulates a logical unit of work, similar to what a controller does in a regular MVC setup. By default, Rails creates a parent ApplicationCable::Channel class (which extends ActionCable::Channel::Base) for encapsulating shared logic between your channels.

### Client-Side Components

#### Connections <br>

Consumers require an instance of the connection on their side. This can be established using JavaScript, which is generated by default by Rails:

    '''
    import { createConsumer } from "@rails/actioncable"

    export default createConsumer()
    ,,,

#### Broadcastings

A broadcasting is a pub/sub link where anything transmitted by a publisher is routed directly to the channel subscribers who are streaming that named broadcasting. Each channel can be streaming zero or more broadcastings.

Broadcastings are purely an online queue and time-dependent. If a consumer is not streaming (subscribed to a given channel), they'll not get the broadcast should they connect later.

---

# Active Record Migrations

### What is Migration?

Migrations uses SQL under the hood.
Migrations can manage the evolution of a schema used by several physical databases. It's a solution to the common problem of adding a field to make a new feature work in your local database, but being unsure of how to push that change to other developers and to the production server. With migrations, you can describe the transformations in self-contained classes that can be checked into version control systems and executed against another database that might be one, two, or five versions behind.

A migration is a subclass of ActiveRecord::Migration that implements two methods: up (perform the required transformations) and down (revert them).

#### Example of a simple migration:

    class CreateProducts < ActiveRecord::Migration
      def up
        create_table :products do |t|
          t.string :name
          t.text :description

          t.timestamps
        end
      end

      def down
        drop_table :products
      end
    end

This migration adds a table called products with a string column called name and a text column called description. A primary key column called id will also be added, however since this is the default we do not need to ask for this. The timestamp columns created_at and updated_at which Active Record populates automatically will also be added. Reversing this migration is as simple as dropping the table.

### How to create migration ?

The model and scaffold generators will create migrations appropriate for adding a new model. This migration will already contain instructions for creating the relevant table. If you tell Rails what columns you want, then statements for adding these columns will also be created. For example, running

    $ rails generate model Product name:string description:text

will create a migration that looks like this

    class CreateProducts < ActiveRecord::Migration
      def change
        create_table :products do |t|
          t.string :name
          t.text :description

          t.timestamps
        end
      end
    end

#### Creating a Standalone Migration

If you are creating migrations for other purposes (for example to add a column to an existing table) then you can also use the migration generator:

    $ rails generate migration AddPartNumberToProducts

If the migration name is of the form “AddXXXToYYY” or “RemoveXXXFromYYY” and is followed by a list of column names and types then a migration containing the appropriate add_column and remove_column statements will be created.

    $ rails generate migration AddPartNumberToProducts part_number:string

will generate

    class AddPartNumberToProducts < ActiveRecord::Migration
      def change
        add_column :products, :part_number, :string
      end
    end


### Can we edit migration file?

Occasionally you will make a mistake when writing a migration. If you have already run the migration then you cannot just edit the migration and run the migration again: Rails thinks it has already run the migration and so will do nothing when you run rake db:migrate. You must rollback the migration (for example with rake db:rollback), edit your migration and then run rake db:migrate to run the corrected version.

In general editing existing migrations is not a good idea: you will be creating extra work for yourself and your co-workers and cause major headaches if the existing version of the migration has already been run on production machines. Instead, you should write a new migration that performs the changes you require.

### How migrations maps datatypes with database ?

Active Record supports the following database column types:

:binary
:boolean
:date
:datetime
:decimal
:float
:integer
:primary_key
:string
:text
:time
:timestamp

These will be mapped onto an appropriate underlying database type. For example, with MySQL the type :string is mapped to VARCHAR(255). You can create columns of types not supported by Active Record when using the non-sexy syntax, for example

      '''
      create_table :products do |t|
      t.column :name, 'polygon', :null => false
      end
      '''

### Use of up/down Methods:

The down method of your migration should revert the transformations done by the up method. In other words, the database schema should be unchanged if you do an up followed by a down. For example, if you create a table in the up method, you should drop it in the down method. It is wise to reverse the transformations in precisely the reverse order they were made in the up method. For example,

    class ExampleMigration < ActiveRecord::Migration
      def up
        create_table :products do |t|
          t.references :category
        end
        #add a foreign key
        execute <<-SQL
          ALTER TABLE products
            ADD CONSTRAINT fk_products_categories
            FOREIGN KEY (category_id)
            REFERENCES categories(id)
        SQL
        add_column :users, :home_page_url, :string
        rename_column :users, :email, :email_address
      end

      def down
        rename_column :users, :email_address, :email
        remove_column :users, :home_page_url
        execute <<-SQL
          ALTER TABLE products
            DROP FOREIGN KEY fk_products_categories
        SQL
        drop_table :products
      end
    end

### Rolling Back

A common task is to rollback the last migration, for example if you made a mistake in it and wish to correct it. Rather than tracking down the version number associated with the previous migration you can run

    $ rake db:rollback

If you need to undo several migrations you can provide a STEP parameter:

    $ rake db:rollback STEP=3

### What are Schema Files for?

Migrations, mighty as they may be, are not the authoritative source for your database schema. Your database remains the authoritative source. By default, Rails generates db/schema.rb which attempts to capture the current state of your database schema.


### References 
[https://medium.com/rubyinside/action-cable-hello-world-with-rails-5-1-efc475b0208b](https://medium.com/rubyinside/action-cable-hello-world-with-rails-5-1-efc475b0208b)

[https://guides.rubyonrails.org/action_cable_overview.html#connection-setup](https://guides.rubyonrails.org/action_cable_overview.html#connection-setup)

[https://www.youtube.com/results?search_query=action+cable+in+rails+6](https://www.youtube.com/results?search_query=action+cable+in+rails+6)

[https://stackify.com/rails-migration-a-complete-guide/](https://stackify.com/rails-migration-a-complete-guide/)

[https://guides.rubyonrails.org/v3.2/migrations.html](https://guides.rubyonrails.org/v3.2/migrations.html)

[https://edgeguides.rubyonrails.org/active_record_migrations.html](https://edgeguides.rubyonrails.org/active_record_migrations.html)
